var main_loop_id = 0;
var loop_check_functions_max_index = 0;
var loop_check_functions = [];
var device = [nil, nil];
var deviceClass = {};

var init_main_loop = func {
    loop_check_functions = [
        pfdCursors,
        checkTrafficProximity,
        checkMarkerBaecon,
        device[0] == nil ? void : func { moveMap (0) },
        checkRollAcquisition,
        checkPitchAcquisition,
        pfdCursors,
        computeAltitudeDiff,
        computeAirspeedDiff,
        device[1] == nil ? void : func { moveMap(1) },
        checkAlerts,
    ];
    loop_check_functions_max_index = size(loop_check_functions);
}

var main_loop = func () {
    getData();
    FLCcomputation();
    loop_check_functions[main_loop_id]();
    main_loop_id += 1;
    if (main_loop_id == loop_check_functions_max_index) main_loop_id = 0;
    settimer(main_loop, 0);
}

var deviceClass = {
    new: func (d) {
        var m = { parents: [ deviceClass ] };
        m.role = d ? 'MFD' : 'PFD';
        m.node = zkv.getNode('device[' ~ d ~ ']', 1);
        m.display  = displayClass.new(m.node, m.role);
        m.display.showInitProgress(m.role);
        m.buttons  = buttonsClass.new(m.node);
        m.knobs    = knobsClass.new(m.node);
        m.softkeys = softkeysClass.new(m.node, m.role);
        m.display.loadsvg();
        m.display.loadGroup([ 
                'Failures',
                'SoftKeysTexts',
                'PFD-Widgets', 
#                'MFD-Widgets',
                'COMM',
                'XPDR-TIME', 
                'NAV',
                'FlightInstruments', 
                'VDI',
                'OMI',
        ], []);
        zkv.getNode(m.role ~ 'init').setIntValue(0);
        m.setstatus(d + 1);
        return m;
    },

    status: 0,

    role: '',

    setstatus: func (s) {
        if (s == 1) {
        }
        elsif (s == 2) {
            me.rootmenu = 12;
            me.node.getNode('mfd-title',1).setValue('TOPO');
        }
        me.status = s;
        me.node.getNode('status', 1).setIntValue(s);
    },

    
    MFD: func {
        m.rootmenu = 12;
        m.newstatus(2);
        m.node.getNode('mfd-title',1).setValue('TOPO');
    },


    MENUkeyItems: {},

    set_MENUkeyItems: func {
        me.MENUkeyItems = {
            'MAIN MENU': [
                    [['ROUTE MANAGER'],   func { me.MENUsoftkey('ROUTE MANAGER') }],
                    [['GENERAL OPTIONS'], func { me.MENUsoftkey('GENERAL OPTIONS') }],
                ],
            'ROUTE MANAGER': [
                    [[sprintf('%sACTIVATE ROUTE MANAGER', getprop('/autopilot/route-manager/active') ? 'DES' : ''), ' '],
                        func { 
                            getprop('/autopilot/route-manager/route/num') or return;
                            setprop('/autopilot/route-manager/current-wp', 0);
                            var v = getprop('/autopilot/route-manager/active');
                            setprop('/autopilot/route-manager/active', !v);
                            me.mud.node.getNode('line[' ~ me.mud.selected.first_line ~ ']').setValue(sprintf('%sACTIVATE ROUTE MANAGER', v ? '' : 'DES'));
                        }],
                    [['SEARCH AIRPORT'], void],
                    [['SEARCH NAVAID'], void],
                    [['SEARCH FIX'], void],
                    [['BACK'], func { me.MENUsoftkey('MAIN MENU') }],
                ],
            'BACKLIGHT LEVEL': [
                    [['HIGH'], func { setprop('/instrumentation/zkv1000/emission', 1.0) }],
                    [['MEDIUM HIGH'], func { setprop('/instrumentation/zkv1000/emission', 0.6) }],
                    [['MEDIUM LOW'], func { setprop('/instrumentation/zkv1000/emission', 0.4) }],
                    [['LOW'], func { setprop('/instrumentation/zkv1000/emission', 0.2) }],
                    [[' ', 'BACK'], func { me.MENUsoftkey('GENERAL OPTIONS') }],
                ],
            'GENERAL OPTIONS': [
                    [['ADJUST BACKLIGHT'], func { me.MENUsoftkey('BACKLIGHT LEVEL') }],
                    [['MAX NAVAIDS SHOW'], void],
                ],
        };
    },
};

var powerOn = func (d) {
    device[d] = deviceClass.new(d);
#    device[d].display.show(device[d].role);
    msg(device[d].role ~ ' switched on!');

#    if (device[abs(d - 1)] == nil) {
#setlistener('/gear/gear/wow', inAirCheckings, 0, 0);
#        fgcommand('reinit', props.Node.new({subsytem : 'xml-autopilot'}));
#        settimer(main_loop, 0);
#    }
#    init_main_loop();
}
